security:
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-providersecurity:
    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers 
    
    encoders:
        App\Entity\Users: 
            algorithm: bcrypt
            cost: 12

    role_hierarchy:
        ROLE_ADMIN: ROLE_COMMUNICATION,ROLE_RECLAMATION,ROLE_CREDIT
        ROLE_COMMUNICATION: ROLE_USER
        ROLE_RECLAMATION: ROLE_USER
        ROLE_CREDIT: ROLE_USER
    
    providers:
        main:
            entity:
                class: App\Entity\Users
                property: email
                
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

        main_login:
            pattern: ^/os-admin/login$
            # anonymous: true
        main:
            pattern: ^/os-admin
            # anonymous: true
            provider: main
            form_login:
                login_path: login
                check_path: login
                default_target_path: /os-admin/
            logout:
                path:   logout
                target: /os-admin/login

            # activate different ways to authenticate

            # http_basic: true
            # https://symfony.com/doc/current/security.html#a-configuring-how-your-users-will-authenticate

            # form_login: true
            # https://symfony.com/doc/current/security/form_login_setup.html

    # Easy way to control access for large sections of your site
    # Note: Only the *first* access control that matches will be used
    access_control:
        - { path: ^/os-admin/login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/os-admin/reset-password, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/os-admin/forgot-password, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/os-admin/first-login, roles: IS_AUTHENTICATED_ANONYMOUSLY }
        - { path: ^/os-admin/users, roles: ROLE_ADMIN }
        - { path: ^/os-admin/profiles, roles: ROLE_ADMIN }
        - { path: ^/os-admin/parameters, roles: ROLE_ADMIN }
        - { path: ^/os-admin/, roles: ROLE_USER }


when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
